// Copyright (C) 1999 Open Source Telecom Corporation.
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef	__APE_SMDI_H__
#define	__APE_SMDI_H__

#ifndef	__APE_THREAD_H__
#include <APE/thread.h>
#endif

#ifndef	__APE_SOCKET_H__
#include <APE/socket.h>
#endif

#ifndef	__APE_SERIAL_H__
#include <APE/serial.h>
#endif

enum
{
	SMDI_DIRECT = 1,
	SMDI_FWDALL,
	SMDI_FWDBUSY,
	SMDI_FWDNA
};

__EXPORT class SMDI : public Thread, public Mutex
{
private:
	time_t	lastio;

protected:
	virtual void OnExit(void)
		{Exit();};

	virtual void OnRing(int desk, int port, int mtype, char *cid, char *fwd)
		{return;};

	virtual void OnStat(char *msg)
		{return;};

	virtual int SendMsgWaiting(char *msg) = 0;
	virtual char *Readline() = 0;
	void Run(void);

public:
	SMDI(int pri);
	virtual ~SMDI();

	int setMsgWaiting(char *target);
	int clrMsgWaiting(char *target);

	int getActivity(void);
};

__EXPORT class SMDISerial : public SMDI, protected Serial
{
protected:
	int SendMsgWaiting(char *msg)
		{return Write(msg);};

	char *Readline(void);

public:
	SMDISerial(char *device, int pri = 0, int long = 1200);
};

__EXPORT class SMDINetwork : public SMDI, protected TCPSocket
{
protected:
	int SendMsgWaiting(char *msg)
		{return Write(msg);};

	char *Readline(void);

public:
	SMDINetwork(InetHostAddress &host, short port, int pri = 0);
};

#endif
